<div class="row justify-content-center">
  <div class="col-9">
    <div class="card p-0">
      <div class="card-header">
        {{'log_forward.sys_log.title' | translate}}
      </div>
      <div class="card-body">
        <form [formGroup]="sysLogSetting" (ngSubmit)="saveLogSetting()">
          <div class="row align-items-center">
            <!-- Status -->
            <div class="col-3 py-1">
              {{'log_forward.sys_log.config_status' | translate}}
            </div>
            <div class="col-9 py-1 d-flex align-items-center">
              <label class="switch switch-pill switch-success mb-0">
                <input type="checkbox" class="switch-input" checked formControlName="config_status"
                  (change)="checkForm($event, deleteSettingModal)">
                <span class="switch-slider"></span>
              </label>
            </div>
            <div class="col-12">
              <div class="row align-items-center">
                <div class="col-9">
                  <div class="row">
                    <!-- IP Address / Domain - Port -->
                    <div class="col-4 py-1">
                      <div class="mt-1">
                        {{'log_forward.sys_log.ip_domain' | translate}}
                      </div>
                    </div>
                    <div class="col-8 py-1">
                      <div class="row">
                        <div class="col-6">
                          <input type="text" class="form-control" formControlName="ip_domain"
                            placeholder="{{'log_forward.sys_log.ip_domain' | translate}}" required
                            [attr.disabled]="!sysLogSetting.get('config_status').value? '' : null">
                          <div
                            *ngIf="sysLogSetting.get('ip_domain').invalid && sysLogSetting.get('ip_domain').dirty || sysLogSetting.get('ip_domain').touched">
                            <span class="form-text text-danger"
                              *ngIf="sysLogSetting.get('ip_domain').touched && sysLogSetting.get('ip_domain').errors?.required">
                              {{'log_forward.sys_log.errors.requiredIpDomain' | translate}}
                            </span>

                            <span class="form-text text-danger"
                              *ngIf="sysLogSetting.get('ip_domain').touched && sysLogSetting.get('ip_domain').errors?.invalidIpDomain">
                              {{'log_forward.sys_log.errors.invalidIpDomain' | translate}}
                            </span>
                          </div>
                        </div>
                        <div class="col-6">
                          <div class="d-flex">
                            <div class="col-auto">
                              <div class="mt-1">
                                {{'log_forward.sys_log.port' | translate}}
                              </div>
                            </div>
                            <div class="col pr-0">
                              <input type="text" class="form-control" formControlName="port"
                                pattern="^([0-9]{1,4}|[1-5][0-9]{4}|6[0-4][0-9]{3}|65[0-4][0-9]{2}|655[0-2][0-9]|6553[0-5])$"
                                placeholder="{{'log_forward.sys_log.port' | translate}}" required
                                [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                              <div
                                *ngIf="sysLogSetting.get('port').invalid && sysLogSetting.get('port').dirty || sysLogSetting.get('port').touched">
                                <span class="form-text text-danger"
                                  *ngIf="sysLogSetting.get('port').touched && sysLogSetting.get('port').errors?.required">
                                  {{'log_forward.sys_log.errors.requiredPort' | translate}}
                                </span>
                                <span class="form-text text-danger"
                                  *ngIf="sysLogSetting.get('port').touched && sysLogSetting.get('port').errors?.pattern">
                                  {{'log_forward.sys_log.errors.invalidPort' | translate}}
                                </span>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>

                    <!-- Protocol -->
                    <div class="col-4 py-1">
                      <div class="mt-1">
                        {{'log_forward.sys_log.protocol' | translate}}
                      </div>
                    </div>

                    <div class="col-8 py-1">
                      <select class="form-control" formControlName="protocol" required
                        [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                        <option *ngFor="let type of PROTOCOLS;" value="{{type.value}}">{{type.label}}</option>
                      </select>

                      <div
                        *ngIf="sysLogSetting.get('protocol').invalid && sysLogSetting.get('protocol').dirty || sysLogSetting.get('protocol').touched">
                        <span class="form-text text-danger"
                          *ngIf="sysLogSetting.get('protocol').touched && sysLogSetting.get('protocol').errors?.required">
                          {{'log_forward.sys_log.errors.requireProtocol' | translate}}
                        </span>
                      </div>
                    </div>

                    <!-- Facility -->
                    <div class="col-4 py-1">
                      <div class="mt-1">
                        {{'log_forward.sys_log.facility' | translate}}
                      </div>
                    </div>

                    <div class="col-8 py-1">
                      <select class="form-control" formControlName="facility" required
                        [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                        <option *ngFor="let facility of facilities;" value="{{facility.value}}">{{facility.label}}
                        </option>
                      </select>

                      <div
                        *ngIf="sysLogSetting.get('facility').invalid && sysLogSetting.get('facility').dirty || sysLogSetting.get('facility').touched">
                        <span class="form-text text-danger"
                          *ngIf="sysLogSetting.get('facility').touched && sysLogSetting.get('facility').errors?.required">
                          {{'log_forward.sys_log.errors.requireFacility' | translate}}
                        </span>
                      </div>
                    </div>

                    <!-- Severity Level -->
                    <div class="col-4 py-1">
                      <div class="mt-1">
                        {{'log_forward.sys_log.severity' | translate}}
                      </div>
                    </div>

                    <div class="col-8 py-1">
                      <select class="form-control" formControlName="severity_level" required
                        [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                        <option *ngFor="let severity of severityLevels;" value="{{severity.value}}">{{severity.label}}
                        </option>
                      </select>

                      <div
                        *ngIf="sysLogSetting.get('severity_level').invalid && sysLogSetting.get('severity_level').dirty || sysLogSetting.get('severity_level').touched">
                        <span class="form-text text-danger"
                          *ngIf="sysLogSetting.get('severity_level').touched && sysLogSetting.get('severity_level').errors?.required">
                          {{'log_forward.sys_log.errors.requireSeverity' | translate}}
                        </span>
                      </div>
                    </div>
                  </div>
                </div>

                <!-- Test connection -->
                <div class="col-3 align-self-start">
                  <button class="btn btn-success btn-lg w-100" (click)="testConnection()" type="button"
                    [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                    <span class="d-none d-md-inline"> {{'log_forward.sys_log.test_connection' | translate}}</span>
                  </button>
                </div>
              </div>
            </div>

            <!-- Log Type -->
            <div class="col-12 py-2">
              <div class="card p-0 mb-1">
                <div class="card-header">
                  {{'log_forward.sys_log.log_type' | translate}}
                </div>
                <div class="card-body">
                  <div *ngFor="let logType of logTypes; let i = index" class="form-check py-1">
                    <input class="form-check-input" type="checkbox" [id]="logType.label + '_' + i"
                      [checked]="sysLogSetting.get('log_type').value.includes(logType.value)"
                      (change)="changeLogType($event, logType)"
                      [attr.disabled]="!sysLogSetting.get('config_status').value ? '' : null">
                    <label class="form-check-label" [for]="logType.label + '_' + i">
                      {{logType.label}}
                    </label>
                  </div>
                </div>
              </div>
              <div
                *ngIf="sysLogSetting.get('config_status').value && (sysLogSetting.get('log_type').value || []).length === 0">
                <span class="form-text text-danger"
                  *ngIf="sysLogSetting.get('log_type').errors?.invalidLogType">{{'log_forward.sys_log.errors.requireLogType'
                  | translate}}</span>
              </div>
            </div>

            <div class="col-12" align="right">
              <button class="btn btn-secondary" type="button" (click)="getSysLogInfo()">
                <span class="d-none d-md-inline"> {{'log_forward.sys_log.cancel' | translate}}</span>
              </button>
              <button type="submit" class="btn btn-primary">
                <span class="d-none d-md-inline"> {{'log_forward.sys_log.save' | translate}}</span>
              </button>
            </div>
          </div>
        </form>
      </div>
    </div>
  </div>


  <!-- Confirm Delete Log Setting -->
  <ng-template #deleteSettingModal let-modal>
    <div>
      <div class="modal-header">
        <h4 class="modal-title" id="modal-delete-log-setting">
          {{'log_forward.snmp.snmp_v1v2c.add_snmp_v1v2_dialog.delete_snmp_community.title' | translate }}</h4>
        <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <div>{{'log_forward.sys_log.delete_setting_modal.message' | translate}}</div>
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" (click)="modal.close('Cancel')">{{'log_forward.sys_log.cancel' |
          translate}}</button>
        <button type="button" class="btn btn-success" (click)="modal.close('Delete')">{{'common.delete' |
          translate}}</button>
      </div>
    </div>
  </ng-template>
</div>